=== debian/changelog ===
groonga (15.2.0-1) unstable; urgency=low

  * New upstream release.

 -- Horimoto Yasuhiro <horimoto@clear-code.com>  Mon, 10 Nov 2025 07:34:25 -0000
