## groonga 15.2.0+dfsg

=== debian/changelog ===
groonga (15.2.0+dfsg-1) unstable; urgency=medium

  * New upstream version 15.2.0+dfsg

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 23 Nov 2025 20:46:10 +0900
