## groonga 15.2.1

=== debian/changelog ===
groonga (15.2.1-1) unstable; urgency=low

  * New upstream release.

 -- Horimoto Yasuhiro <horimoto@clear-code.com>  Tue, 02 Dec 2025 05:53:11 -0000
