=== debian/changelog ===
groonga (15.2.1+dfsg-1) unstable; urgency=medium

  * New upstream version 15.2.1+dfsg

 -- Kentaro Hayashi <kenhys@xdump.org>  Mon, 08 Dec 2025 13:17:24 +0900
