## groonga 15.2.3

=== debian/changelog ===
groonga (15.2.3-1) unstable; urgency=low

  * New upstream release.

 -- Horimoto Yasuhiro <horimoto@clear-code.com>  Thu, 15 Jan 2026 06:54:24 -0000

groonga (15.2.2-1) unstable; urgency=low

  * New upstream release.

 -- Horimoto Yasuhiro <horimoto@clear-code.com>  Thu, 25 Dec 2025 02:36:36 -0000
