=== tools/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.

# Common Utilities
add_subdirectory(arg)
add_subdirectory(fileio)
add_subdirectory(io)
add_subdirectory(logger)
add_subdirectory(time)

# Tools
add_subdirectory(parquet)
add_subdirectory(sddl)
add_subdirectory(streamdump)
add_subdirectory(training)
add_subdirectory(protobuf)
