=== debian/changelog ===
groonga (15.2.3+dfsg-1) unstable; urgency=medium

  * New upstream version 15.2.3+dfsg
  * debian/control:
    - Bump version to 4.7.3.
    - Drop needless Priority: optional by default
    - Drop Rules-Requires-Root: no by default

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 18 Jan 2026 21:41:56 +0900
