## groonga 15.2.4

=== debian/changelog ===
groonga (15.2.4-1) unstable; urgency=low

  * New upstream release.

 -- Horimoto Yasuhiro <horimoto@clear-code.com>  Thu, 29 Jan 2026 00:59:53 -0000
