## groonga 15.2.5

=== debian/changelog ===
groonga (15.2.5-1) unstable; urgency=low

  * New upstream release.

 -- Horimoto Yasuhiro <horimoto@clear-code.com>  Fri, 30 Jan 2026 09:32:54 -0000
