=== debian/control ===
--- 
+++ 
@@ -6,12 +6,12 @@
 Build-Depends:
   cmake,
   debhelper (>= 12),
-#  libblas-dev,
+  libblas-dev,
   libcurl4-openssl-dev,
   libedit-dev,
   libevent-dev,
-  libfaiss-dev,
-#  liblapack-dev,
+#  libfaiss-dev,
+  liblapack-dev,
   liblz4-dev,
   libmecab-dev,
   libmsgpack-dev,
